# cache2k 1.3.2.Alpha

This is a preview release for evaluation purposes and should not be used in production.

## New and Noteworthy

- Synchronous execution of expiry listener

## Possible Breakages

`Cache2kBuilder.addListener` will execute an `EntryExpiredLister` synchronously. In version
1.2 an expiry listener was always executed asynchronously. This is an potentially incompatible 
change, in case expiry listeners are used. Review the existing client code and
make sure that addAsyncListeners is used for an `EntryExpiredLister` if that is wanted.

## API Changes 

- Deprecated IntCache and LongCache

## Fixes and Improvements

- Deprecated IntCache and LongCache
- Revert deprecation of `ExceptionPropagator` introduced in version 1.3.1
- Internal: Improvement and simplification of `ExceptionPropagator` handling
- fix missing expiry listener call after a created listener call, in case expiry during the insert
- `expiry`, `expireAfterWrite`, `refresAhead`: Fix race condition of a `Cache.put` and the
  termination of the probation period after a refresh.
- `Cache.invoke` / `EntryProcessor`:  Internal improvements when using listeners: avoid unnecessary entry reads
- race of refresh and delete: if an entry is deleted via `Cache.remove` it was not
  reappearing when refreshed concurrently
- internal cleanup: use common code for refresh in different cache variants
- eviction efficiency fix for a few special short traces