# cache2k 2.5.2.Alpha "Cogee Beach"

This is a preview release for evaluation purposes and should not be used in production.
The final release is planed as *"Cogee Beach" - **2.6.0.Final***.

## Fixes and Improvements

- `eternal(true/false)` / `MutableEntry.setExpiryTime`: Expiry can be modified, although 
  no other expiry setting is present, or in other words: the timer support is available by
  default. If `eternal(true)` is configured, timer support is disabled and
  `Cache.invoke` / `MutableEntry.setExpiryTime` or `Cache.expireAt` cannot be used 
- `Cache.invoke` / `MutableEntry.setExpiryTime`: has no effect if entry is not existing 
- `Cache.invoke` / `MutableEntry.getExpiryTime` always returns positive time value
- CI tests with Android API level 26 and API level 30
- Expiry: handle time values close to `Long.MAX_VALUE` without overflow, although the application
  should not produce these.
- Support `Duration` for duration parameters in the `Cache2kBuilder`
- Config section `InternalConfig` in `cache2k-core` for specific tuning values that
  should not be exposed in the public API
- Spring support: `SpringCache2kDefaultSupplier` provides default setup and manager context
- Spring support: `SpringCache2kManager.setDefaultCacheNames()` added
- Spring support: `SpringCache2kManager.addCache(String, Function)`
- Spring support: added `SpringCache2kDefaultCustomizer`
- Corrected signature `BulkCacheLoader.BulkCallback.onLoadFailure(Set, Exception)` to
  onLoadFailure(Iterable, Exception)

## Possible breakages

Changes that may break existing applications. 

- Spring support: `SpringCache2kManager.defaultSetup` throws `IllegalStateException`
  if not called before caches are added
- `EXPIRY_NOT_ETERNAL` constant removed from `Cache2kConfig`
- Fixed generic typing issues in `org.cache2k.config` package
- `Sechduler.schedule` uses delay duration instead of absolute time
- `TimeReference.millis()` renamed to `ticks()` and additional conversion methods to support 
- other time resolutions than milliseconds
- Safety gap system property for sharp timeout changed to: `org.cache2k.sharpExpirySafetyGapMillis`
- Removed capability to modify internal constants via `Tunable`
- removed `SpringCache2kCacheManager.setCaches(Collection<Cache2kConfig<?, ?>> cacheConfigurationList)`

## Non Functional Improvements

- Started with tests based on JUnit 5
- Documentation and examples for expiry, expiry policy
- Documentation improvements, fixed many typos and grammar errors in the API package

## Credits

- Marcel Schnelle, [mannodermaus](https://github.com/mannodermaus) for the contribution of 
  Android CI tests, [PR#178](https://github.com/cache2k/cache2k/pull/178) 