# cache2k 2.5.3.Beta "Cogee Beach"

This is a preview release for evaluation purposes and should not be used in production.
The final release is planed as *"Cogee Beach" - **2.6.0.Final***.

## API Change

- Added `CacheClosedException`, moved from `org.cache2k.core`

## Fixes and Improvements

- `CacheClosedListener`: Wait for `CompletableFuture`
- Simplify integrity checking, remove integrity state from toString output
- API: add/correct @Nullable annotations in `ExpiryPolicy` and `AsyncCacheLoader` 
- `Cache.invoke`: Set expiry time correctly for exception propagation, in case 
  `setException` and `setExpiry` is used atomically
- `CacheInfo.getExpiryAfterWriteTicks`, `CacheInfo.getTimeReference()`: added 
- `CacheControl.getCapacityLimit` returns maximum weight correctly when weigher is present

## Possible breakages

- `Cache.expireAt()` and `MutableCacheEntry.setExpiryTime()`: the maximum expiry time is capped by
  the specified `expireAfterWriteDuration`, this aligns the behavior with the `ExpiryPolicy`.
  The rationale is, that an (application) user, when setting `expireAfterWrite` expects that
  this duration is never exceeded.

