# cache2k 2.6.1.Final "Cogee Beach"

This change log lists the changes since [2.6.0.Final](/2/6.0.Final.html).

## Fixes and Improvements

- Timer: Reduce scheduler events
- Timer: Correct scheduling time if an earlier expiry is inserted. Maximum lag time criteria was not met in this case.
- Timer: Rare case if only one cache entry with TTL and regular updates is used, leeds to continuous increase of scheduling events

## Using this cache2k version

The binaries are available on maven central.

### For Java SE/EE and Android environments

For Maven users:

````
    <dependency>
      <groupId>${project.groupId}</groupId>
      <artifactId>cache2k-api</artifactId>
      <version>2.6.1.Final</version>
    </dependency>
    <dependency>
      <groupId>${project.groupId}</groupId>
      <artifactId>cache2k-core</artifactId>
      <version>2.6.1.Final</version>
      <scope>runtime</scope>
    </dependency>
````

For Gradle users:

````
def cache2kVersion = '2.6.1.Final'

dependencies {
    implementation "org.cache2k:cache2k-api:${cache2kVersion}"
    runtimeOnly "org.cache2k:cache2k-core:${cache2kVersion}"
}
````

### Using the JCache / JSR107 provider

Maven users include the cache2k JCache provider this way:

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-jcache</artifactId>
      <version>2.6.1.Final</version>
      <scope>runtime</scope>
    </dependency>
````

For Gradle users:

````
dependencies {
    runtimeOnly "org.cache2k:cache2k-jcache:2.6.1.Final"
}
````

Implementation details, tuning tips and hints on configuration can be found at: [JCache - cache2k User Guide](https://cache2k.org/docs/latest/user-guide.html#jcache)

